<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/AccessoryServo.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('AccessoryServo_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">AccessoryServo.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Accessories&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Class for a servo accessory&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Accessories_8h.html">Accessories.h</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_SERVO</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;ActionsStack.hpp&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#aff937dbf8b0adc731c408bafeae3ea35">   12</a></span>&#160;<a class="code" href="classAccessoryServo.html#aff937dbf8b0adc731c408bafeae3ea35">AccessoryServo::AccessoryServo</a>()</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a> = NULL;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    this-&gt;minimumPosition = 0;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    this-&gt;maximumPosition = 180;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    this-&gt;powerState = PowerNoAction;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;}</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#a34b0fe645b1cadd12aae4c09574c8bc5">   20</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryServo.html#a34b0fe645b1cadd12aae4c09574c8bc5">AccessoryServo::begin</a>(<a class="code" href="classPort.html">Port</a> *inpPort, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inDurationMilli, </div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keywordtype">int</span> inMinimumPosition, <span class="keywordtype">int</span> inMaximumPosition, <span class="keywordtype">int</span> inMovingPositionsNumber)</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;{</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a> = inpPort;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#a6e68b4693371383dfb026869af30d1d2">SetDuration</a>(inDurationMilli);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <a class="code" href="classAccessory.html#af94464d9b49e5700d3c20d0cd206ac51">Accessory::begin</a>(STATE_NONE);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    this-&gt;minimumPosition = inMinimumPosition;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    this-&gt;maximumPosition = inMaximumPosition;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a> = STATE_NONE;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    inpPort-&gt;<a class="code" href="classPort.html#a101241b7b8e820f3d0da3c435ad1b66e">beginByAccessory</a>(this-&gt;minimumPosition);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a> = MINIMUM;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    this-&gt;currentPosition = this-&gt;minimumPosition;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    this-&gt;targetPosition = -1;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    this-&gt;targetSpeed = 0;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    this-&gt;powerCommandPin = (GPIO_pin_t)DP_INVALID;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    this-&gt;powerDelay = 0;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    this-&gt;powerState = PowerNoAction;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">AdjustMovingPositionsSize</a>(inMovingPositionsNumber);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;}</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#a3bd387a1bcb96c2606b25587f8fa0d37">   41</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryServo.html#a3bd387a1bcb96c2606b25587f8fa0d37">AccessoryServo::SetPowerCommand</a>(<span class="keywordtype">int</span> inPin, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inDelay)</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;{</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    this-&gt;powerCommandPin = Arduino_to_GPIO_pin(inPin);</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    pinMode2f(this-&gt;powerCommandPin, OUTPUT);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    digitalWrite2f(this-&gt;powerCommandPin, HIGH);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    this-&gt;powerDelay = inDelay;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;}</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#ab47b783dff3fd9cfd7049e8840edce65">   51</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryServo.html#ab47b783dff3fd9cfd7049e8840edce65">AccessoryServo::MoveMinimum</a>()</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;{</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;AccessoryServo MoveMinimum()&quot;</span>));</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(this-&gt;minimumPosition);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;}</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#aa88f41f41c130228f2a410be6e0b037b">   60</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryServo.html#aa88f41f41c130228f2a410be6e0b037b">AccessoryServo::MoveMaximum</a>()</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;{</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;AccessoryServo MoveMaximum()&quot;</span>));</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(this-&gt;maximumPosition);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;}</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#a76f430b0a0525e6b168d2c9deb7d6347">   69</a></span>&#160;ACC_STATE <a class="code" href="classAccessoryServo.html#a76f430b0a0525e6b168d2c9deb7d6347">AccessoryServo::MoveToggle</a>()</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;{</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">IsActionDelayPending</a>())</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">return</span> this-&gt;<a class="code" href="classAccessory.html#a6b837b3afb75f5eadcde5e1742db5c7d">GetState</a>();</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryServo MoveToggle() : &quot;</span>));</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a> == MAXIMUM)</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(this-&gt;minimumPosition);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(this-&gt;maximumPosition);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordflow">return</span> this-&gt;<a class="code" href="classAccessory.html#a6b837b3afb75f5eadcde5e1742db5c7d">GetState</a>();</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;}</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="keywordtype">void</span> AccessoryServo::SetState(ACC_STATE inState) </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;{ </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryServo SetState(&quot;</span>));</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">switch</span> (inState)</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    {</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keywordflow">case</span> MINIMUM:</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;            Serial.println(F(<span class="stringliteral">&quot;MINIMUM)&quot;</span>));</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(this-&gt;minimumPosition);</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <span class="keywordflow">case</span> MAXIMUM:</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            Serial.println(F(<span class="stringliteral">&quot;MAXIMUM)&quot;</span>));</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(this-&gt;maximumPosition);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="keywordflow">default</span>:</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>();</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    }</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;}</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#acb11e2c5c1b802c18fe5f146001a2baa">  113</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryServo.html#acb11e2c5c1b802c18fe5f146001a2baa">AccessoryServo::Move</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;{</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;AccessoryServo Move()&quot;</span>));</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">GetMovingPositionSize</a>() == 1)</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    {</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#a76f430b0a0525e6b168d2c9deb7d6347">MoveToggle</a>();</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    }</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">SetLastMovingPosition</a>(this-&gt;<a class="code" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">IndexOfMovingPosition</a>(inId));</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordtype">int</span> position = this-&gt;<a class="code" href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">GetMovingPosition</a>(inId);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keywordflow">if</span> (position == MINIMUM || position == MAXIMUM)</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        this-&gt;SetState((ACC_STATE)position);</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(position);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;}</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">  134</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">AccessoryServo::MovePosition</a>(<span class="keywordtype">int</span> inPosition)</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;{</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">IsActionDelayPending</a>() &amp;&amp; !<a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a>)</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    this-&gt;InternalMovePosition(inPosition);</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;}</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#a3fce38eaa89e64a11a18644fcd2d0fca">  142</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryServo.html#a3fce38eaa89e64a11a18644fcd2d0fca">AccessoryServo::Event</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;{</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">switch</span> (inEvent)</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    {</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_TOGGLE:</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#acb11e2c5c1b802c18fe5f146001a2baa">Move</a>(inId);</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVE:</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keywordflow">switch</span> (inData)</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        {</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_STRAIGHT:</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_TOP:</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_LEFT:</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            this-&gt;<a class="code" href="classAccessoryServo.html#ab47b783dff3fd9cfd7049e8840edce65">MoveMinimum</a>();</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_DIVERGE:</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_BOTTOM:</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_RIGHT:</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            this-&gt;<a class="code" href="classAccessoryServo.html#aa88f41f41c130228f2a410be6e0b037b">MoveMaximum</a>();</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_OFF:</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_STOP:</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#a63cfeea67bec1eab18758d74cd435c00">MoveStop</a>();</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>();</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a>(STOP);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_MORE:</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_LESS:</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;            <span class="keywordtype">int</span> pos = this-&gt;currentPosition + inData;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            <span class="keywordflow">if</span> (pos &gt; this-&gt;maximumPosition)</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                pos = this-&gt;maximumPosition;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            <span class="keywordflow">if</span> (pos &lt; this-&gt;minimumPosition)</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;                pos = this-&gt;minimumPosition;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(pos);</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;            }</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        }</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITION:</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">MovePosition</a>(inData);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITIONID:</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#acb11e2c5c1b802c18fe5f146001a2baa">Move</a>(inId);</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITIONINDEX:</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        this-&gt;<a class="code" href="classAccessoryServo.html#acb11e2c5c1b802c18fe5f146001a2baa">Move</a>(this-&gt;<a class="code" href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">GetMovingPositionIdByIndex</a>(inData));</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_SETSPEED:</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(inData);</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <span class="keywordflow">default</span>:</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    }</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;}</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="keywordtype">void</span> AccessoryServo::InternalMovePosition(<span class="keywordtype">int</span> inPosition)</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;{</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordflow">if</span> (this-&gt;currentPosition == inPosition)</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    {</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;AccessoryServo::MovePosition : same position - no move!&quot;</span>));</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    }</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;AccessoryServo InternalMovePosition()&quot;</span>));</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    MovementSpeed speed = this-&gt;<a class="code" href="classAccessoryServo.html#a9a7748426c761fda3f018d7e8310c9ed">GetMovementSpeed</a>();</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <span class="keywordflow">switch</span> (speed)</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    {</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keywordflow">case</span> ServoFast:</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#a960a487c2833fc23e9285a7615f41379">MovePosition</a>(this-&gt;<a class="code" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">GetDuration</a>(), inPosition);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        this-&gt;currentPosition = inPosition;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    <span class="keywordflow">case</span> ServoAlone:</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> pos = this-&gt;currentPosition; pos &lt; inPosition; pos++)</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#a960a487c2833fc23e9285a7615f41379">MovePosition</a>(this-&gt;GetDuration(), pos);</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        this-&gt;currentPosition = inPosition;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    <span class="keywordflow">case</span> ServoActionStack:</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        this-&gt;targetPosition = inPosition;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        this-&gt;targetSpeed = (this-&gt;currentPosition &lt; this-&gt;targetPosition) ? 1 : -1;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        <a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a> = <span class="keyword">true</span>;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    <span class="keywordflow">case</span> ServoSlow:</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        this-&gt;targetPosition = inPosition;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        this-&gt;targetSpeed = (this-&gt;currentPosition &lt; this-&gt;targetPosition) ? 1 : -1;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    }</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    <span class="keywordflow">if</span> (inPosition == this-&gt;minimumPosition)</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    {</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        this-&gt;<a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a>(MINIMUM);</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        this-&gt;<a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a> = MINIMUM;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    }</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        <span class="keywordflow">if</span> (inPosition == this-&gt;maximumPosition)</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        {</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a>(MAXIMUM);</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a> = MAXIMUM;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        }</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        {</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a>(STATE_NONE);</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a> = STATE_NONE;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        }</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;}</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;<span class="keywordtype">bool</span> AccessoryServo::ActionEnded()</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;{</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#a8a9a9e26544b859289f125dd075cf52e">GetActionStartingMillis</a>() &lt;= 0)</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <span class="keywordflow">if</span> (this-&gt;powerCommandPin == DP_INVALID || this-&gt;powerState == PowerRunning)</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    {</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="comment">//if (millis() - this-&gt;GetActionStartingMillis() &gt; this-&gt;GetDuration())</span></div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        {</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            <span class="keywordflow">if</span> (this-&gt;targetSpeed == 0)</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            {</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;                <span class="comment">// Abort</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;                this-&gt;targetPosition = -1;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;                <a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a> = <span class="keyword">false</span>;</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;                <span class="keywordflow">if</span> (this-&gt;powerState == PowerRunning &amp;&amp; this-&gt;powerCommandPin != DP_INVALID)</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;                {</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;                    Serial.println(F(<span class="stringliteral">&quot;AccessoryServo after running&quot;</span>));</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;                    this-&gt;powerState = PowerAfterRunning;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;                    <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;                }</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;                this-&gt;<a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>();</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            }</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            this-&gt;currentPosition += this-&gt;targetSpeed;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#a960a487c2833fc23e9285a7615f41379">MovePosition</a>(this-&gt;<a class="code" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">GetDuration</a>(), this-&gt;currentPosition);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;            <span class="keywordflow">if</span> (this-&gt;targetPosition == this-&gt;currentPosition)</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            {</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;                this-&gt;targetPosition = -1;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;                this-&gt;targetSpeed = 0;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;                <a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a> = <span class="keyword">false</span>;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;                <span class="keywordflow">if</span> (this-&gt;powerState == PowerRunning &amp;&amp; this-&gt;powerCommandPin != DP_INVALID)</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;                {</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                    Serial.println(F(<span class="stringliteral">&quot;AccessoryServo after running&quot;</span>));</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;                    this-&gt;powerState = PowerAfterRunning;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;                    <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;                }</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;                this-&gt;<a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>();</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;            }</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;            <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        }</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    }</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    {</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        <span class="keywordflow">if</span> (this-&gt;powerState == PowerNoAction)</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        {</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            Serial.println(F(<span class="stringliteral">&quot;AccessoryServo start power command&quot;</span>));</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;            digitalWrite2f(this-&gt;powerCommandPin, LOW);</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;            this-&gt;powerState = PowerBeforeRunning;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;            <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        }</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <span class="comment">// Action time elapsed, do the next work...</span></div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        <span class="keywordflow">if</span> (millis() - this-&gt;<a class="code" href="classAccessory.html#a8a9a9e26544b859289f125dd075cf52e">GetActionStartingMillis</a>() &gt; this-&gt;powerDelay)</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;        {</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            <span class="keywordflow">if</span> (this-&gt;powerState == PowerBeforeRunning)</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;            {</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;                Serial.println(F(<span class="stringliteral">&quot;AccessoryServo running&quot;</span>));</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                this-&gt;powerState = PowerRunning;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;                <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;            }</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            <span class="keywordflow">if</span> (this-&gt;powerState == PowerAfterRunning)</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;            {</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;                Serial.println(F(<span class="stringliteral">&quot;AccessoryServo end running&quot;</span>));</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;                this-&gt;powerState = PowerNoAction;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;                digitalWrite2f(this-&gt;powerCommandPin, HIGH);</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;                this-&gt;<a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>();</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            }</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        }</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    }</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;}</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;</div><div class="line"><a name="l00358"></a><span class="lineno"><a class="line" href="classAccessoryServo.html#a9a7748426c761fda3f018d7e8310c9ed">  358</a></span>&#160;MovementSpeed <a class="code" href="classAccessoryServo.html#a9a7748426c761fda3f018d7e8310c9ed">AccessoryServo::GetMovementSpeed</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">GetDuration</a>() == 0)</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keywordflow">return</span> ServoFast;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">GetDuration</a>() &lt; 6)</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        <span class="keywordflow">return</span> ServoAlone;</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">GetDuration</a>() &lt; 20)</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        <span class="keywordflow">return</span> ServoActionStack;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    <span class="keywordflow">return</span> ServoSlow;</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;}</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessoryServo.html#a8e7338a290d34c194e7d351a8d4abaa5">AccessoryServo::EEPROMLoad</a>(<span class="keywordtype">int</span> inPos)</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;{</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    inPos = this-&gt;<a class="code" href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">Accessory::EEPROMLoad</a>(inPos);</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    <span class="keywordflow">if</span> (this-&gt;powerCommandPin != DP_INVALID)</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        digitalWrite2f(this-&gt;powerCommandPin, HIGH);</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#a960a487c2833fc23e9285a7615f41379">MovePosition</a>(0, this-&gt;currentPosition);</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    delay(200); <span class="comment">//can be done here because we are in setup timing...</span></div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    <span class="keywordflow">if</span> (this-&gt;powerCommandPin != DP_INVALID)</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;        digitalWrite2f(this-&gt;powerCommandPin, LOW);</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    <span class="keywordflow">return</span> inPos;</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;}</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;<span class="keywordtype">void</span> AccessoryServo::printAccessory()</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;{</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;    Servo : &quot;</span>));</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;<a class="code" href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">GetMovingPositionSize</a>(); i++)</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    {</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / ID &quot;</span>));</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;        Serial.print(this-&gt;<a class="code" href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">GetMovingPositionIdByIndex</a>(i));</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; - &quot;</span>));</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        Serial.print(this-&gt;<a class="code" href="classAccessory.html#a62eee418f630f805d36f6005e0db1a9e">GetMovingPositionByIndex</a>(i));</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    }</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>() != NULL)</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    {</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / Speed &quot;</span>));</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;        Serial.print(this-&gt;<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>()-&gt;GetSpeed());</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;    }</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;    <span class="keywordflow">if</span> (this-&gt;powerCommandPin != (GPIO_pin_t)DP_INVALID)</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    {</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / PowerPin &quot;</span>));</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;        Port::printPortPin(this-&gt;powerCommandPin, DIGITAL);</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / PowerDelay &quot;</span>));</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        Serial.print(this-&gt;powerDelay);</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    }</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Delay &quot;</span>));</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;    Serial.print(this-&gt;<a class="code" href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">GetDebounceDelay</a>());</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;ms / &quot;</span>));</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>() != NULL)</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;        this-&gt;<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>()-&gt;printPort();</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    Serial.println(F(<span class="stringliteral">&quot; &quot;</span>));</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;}</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classAccessory_html_ac818b7112183d3d65ec361c8402f927f"><div class="ttname"><a href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">Accessory::GetDebounceDelay</a></div><div class="ttdeci">unsigned int GetDebounceDelay() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00243">Accessory.hpp:243</a></div></div>
<div class="ttc" id="classAccessory_html_ac2883977d969dcde8f078934b4a9ed12"><div class="ttname"><a href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">Accessory::GetPort</a></div><div class="ttdeci">Port * GetPort() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00185">Accessory.hpp:185</a></div></div>
<div class="ttc" id="classAccessoryServo_html_a8e7338a290d34c194e7d351a8d4abaa5"><div class="ttname"><a href="classAccessoryServo.html#a8e7338a290d34c194e7d351a8d4abaa5">AccessoryServo::EEPROMLoad</a></div><div class="ttdeci">int EEPROMLoad(int inPos)</div></div>
<div class="ttc" id="classAccessory_html_a8a9a9e26544b859289f125dd075cf52e"><div class="ttname"><a href="classAccessory.html#a8a9a9e26544b859289f125dd075cf52e">Accessory::GetActionStartingMillis</a></div><div class="ttdeci">unsigned long GetActionStartingMillis() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00366">Accessory.hpp:366</a></div></div>
<div class="ttc" id="classAccessory_html_ab1dad31ee3bcac4b1baf9a140c7fa57d"><div class="ttname"><a href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">Accessory::StartAction</a></div><div class="ttdeci">virtual void StartAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00077">Accessory.cpp:77</a></div></div>
<div class="ttc" id="classAccessory_html_a8cfe1c1ca32753832146656755f6e7a7"><div class="ttname"><a href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">Accessory::GetDuration</a></div><div class="ttdeci">unsigned long GetDuration() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00254">Accessory.hpp:254</a></div></div>
<div class="ttc" id="classAccessoryServo_html_a9a7748426c761fda3f018d7e8310c9ed"><div class="ttname"><a href="classAccessoryServo.html#a9a7748426c761fda3f018d7e8310c9ed">AccessoryServo::GetMovementSpeed</a></div><div class="ttdeci">MovementSpeed GetMovementSpeed() const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00358">AccessoryServo.cpp:358</a></div></div>
<div class="ttc" id="classPort_html_a676359ed59bf5091126fd96e1a04cafa"><div class="ttname"><a href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">Port::SetSpeed</a></div><div class="ttdeci">virtual int SetSpeed(int inSpeed)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00108">Port.cpp:108</a></div></div>
<div class="ttc" id="classAccessory_html_a4f0410f39fa692494b51bc880714bdd1"><div class="ttname"><a href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">Accessory::GetMovingPositionIdByIndex</a></div><div class="ttdeci">unsigned long GetMovingPositionIdByIndex(int inIndex) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00313">Accessory.hpp:313</a></div></div>
<div class="ttc" id="classAccessory_html_a60e5e9122c96773c975fe9d2c2db6520"><div class="ttname"><a href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">Accessory::SetStateRaw</a></div><div class="ttdeci">void SetStateRaw(ACC_STATE inNewState)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00165">Accessory.cpp:165</a></div></div>
<div class="ttc" id="classPort_html_a63cfeea67bec1eab18758d74cd435c00"><div class="ttname"><a href="classPort.html#a63cfeea67bec1eab18758d74cd435c00">Port::MoveStop</a></div><div class="ttdeci">virtual void MoveStop()</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00167">Port.hpp:167</a></div></div>
<div class="ttc" id="classActionsStack_html_aef1d9742f23cad44c4e85e0cfdf942e9"><div class="ttname"><a href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a></div><div class="ttdeci">static bool FillingStack</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00071">ActionsStack.hpp:71</a></div></div>
<div class="ttc" id="classAccessory_html_aa249535a3c36291764e38ab1e4ae4cee"><div class="ttname"><a href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">Accessory::GetMovingPosition</a></div><div class="ttdeci">int GetMovingPosition(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00068">Accessory.cpp:68</a></div></div>
<div class="ttc" id="classAccessory_html_a224977dffaa54df56def6a7b15af0031"><div class="ttname"><a href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">Accessory::IndexOfMovingPosition</a></div><div class="ttdeci">uint8_t IndexOfMovingPosition(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00059">Accessory.cpp:59</a></div></div>
<div class="ttc" id="classAccessory_html_a5e837b6c4251c2fe69066d3146dd8478"><div class="ttname"><a href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">Accessory::SetLastMovingPosition</a></div><div class="ttdeci">void SetLastMovingPosition(uint8_t inLastPositionIndex)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00157">Accessory.cpp:157</a></div></div>
<div class="ttc" id="classAccessory_html_ac4dc998e8f09ac7f94a3e06c56e8d5d4"><div class="ttname"><a href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">Accessory::GetMovingPositionSize</a></div><div class="ttdeci">const uint8_t GetMovingPositionSize() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00323">Accessory.hpp:323</a></div></div>
<div class="ttc" id="classAccessory_html_a62eee418f630f805d36f6005e0db1a9e"><div class="ttname"><a href="classAccessory.html#a62eee418f630f805d36f6005e0db1a9e">Accessory::GetMovingPositionByIndex</a></div><div class="ttdeci">int GetMovingPositionByIndex(int inIndex) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00307">Accessory.hpp:307</a></div></div>
<div class="ttc" id="classAccessoryServo_html_acb11e2c5c1b802c18fe5f146001a2baa"><div class="ttname"><a href="classAccessoryServo.html#acb11e2c5c1b802c18fe5f146001a2baa">AccessoryServo::Move</a></div><div class="ttdeci">void Move(unsigned long inId)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00113">AccessoryServo.cpp:113</a></div></div>
<div class="ttc" id="classAccessory_html_a3de65543a892b3418df72f54439605cb"><div class="ttname"><a href="classAccessory.html#a3de65543a892b3418df72f54439605cb">Accessory::ResetAction</a></div><div class="ttdeci">virtual void ResetAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00385">Accessory.hpp:385</a></div></div>
<div class="ttc" id="classAccessory_html_a6b837b3afb75f5eadcde5e1742db5c7d"><div class="ttname"><a href="classAccessory.html#a6b837b3afb75f5eadcde5e1742db5c7d">Accessory::GetState</a></div><div class="ttdeci">ACC_STATE GetState() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00209">Accessory.hpp:209</a></div></div>
<div class="ttc" id="classPort_html_a960a487c2833fc23e9285a7615f41379"><div class="ttname"><a href="classPort.html#a960a487c2833fc23e9285a7615f41379">Port::MovePosition</a></div><div class="ttdeci">virtual void MovePosition(unsigned long inDuration, int inEndPosition)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00173">Port.hpp:173</a></div></div>
<div class="ttc" id="classAccessory_html_ae8c3ad3e37a2ba5914f419abd3e2426f"><div class="ttname"><a href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">Accessory::IsActionDelayPending</a></div><div class="ttdeci">bool IsActionDelayPending() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00398">Accessory.hpp:398</a></div></div>
<div class="ttc" id="classAccessoryServo_html_a76f430b0a0525e6b168d2c9deb7d6347"><div class="ttname"><a href="classAccessoryServo.html#a76f430b0a0525e6b168d2c9deb7d6347">AccessoryServo::MoveToggle</a></div><div class="ttdeci">ACC_STATE MoveToggle()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00069">AccessoryServo.cpp:69</a></div></div>
<div class="ttc" id="classAccessoryServo_html_aa88f41f41c130228f2a410be6e0b037b"><div class="ttname"><a href="classAccessoryServo.html#aa88f41f41c130228f2a410be6e0b037b">AccessoryServo::MoveMaximum</a></div><div class="ttdeci">void MoveMaximum()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00060">AccessoryServo.cpp:60</a></div></div>
<div class="ttc" id="classAccessoryServo_html_ad12214b347143b4b2dc9ae8c5aa42418"><div class="ttname"><a href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">AccessoryServo::MovePosition</a></div><div class="ttdeci">void MovePosition(int inPosition)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00134">AccessoryServo.cpp:134</a></div></div>
<div class="ttc" id="classAccessoryServo_html_ab47b783dff3fd9cfd7049e8840edce65"><div class="ttname"><a href="classAccessoryServo.html#ab47b783dff3fd9cfd7049e8840edce65">AccessoryServo::MoveMinimum</a></div><div class="ttdeci">void MoveMinimum()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00051">AccessoryServo.cpp:51</a></div></div>
<div class="ttc" id="classAccessoryServo_html_a3fce38eaa89e64a11a18644fcd2d0fca"><div class="ttname"><a href="classAccessoryServo.html#a3fce38eaa89e64a11a18644fcd2d0fca">AccessoryServo::Event</a></div><div class="ttdeci">void Event(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00142">AccessoryServo.cpp:142</a></div></div>
<div class="ttc" id="classAccessoryServo_html_a3bd387a1bcb96c2606b25587f8fa0d37"><div class="ttname"><a href="classAccessoryServo.html#a3bd387a1bcb96c2606b25587f8fa0d37">AccessoryServo::SetPowerCommand</a></div><div class="ttdeci">void SetPowerCommand(int inPin, unsigned long inDelay = 100)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00041">AccessoryServo.cpp:41</a></div></div>
<div class="ttc" id="classAccessory_html_acd67b5953eb1b55a52a87a779574e3b6"><div class="ttname"><a href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">Accessory::AdjustMovingPositionsSize</a></div><div class="ttdeci">void AdjustMovingPositionsSize(uint8_t inNewSize)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00029">Accessory.cpp:29</a></div></div>
<div class="ttc" id="classPort_html_a101241b7b8e820f3d0da3c435ad1b66e"><div class="ttname"><a href="classPort.html#a101241b7b8e820f3d0da3c435ad1b66e">Port::beginByAccessory</a></div><div class="ttdeci">virtual void beginByAccessory(int inStartingPosition)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00105">Port.hpp:105</a></div></div>
<div class="ttc" id="classAccessory_html_a245ad3bad4fa0f1d657fdc20b2edb868"><div class="ttname"><a href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">Accessory::EEPROMLoad</a></div><div class="ttdeci">virtual int EEPROMLoad(int inPos)</div></div>
<div class="ttc" id="classAccessory_html_af94464d9b49e5700d3c20d0cd206ac51"><div class="ttname"><a href="classAccessory.html#af94464d9b49e5700d3c20d0cd206ac51">Accessory::begin</a></div><div class="ttdeci">void begin(ACC_STATE inStartingState = STATE_NONE)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00180">Accessory.hpp:180</a></div></div>
<div class="ttc" id="classAccessory_html_a6e68b4693371383dfb026869af30d1d2"><div class="ttname"><a href="classAccessory.html#a6e68b4693371383dfb026869af30d1d2">Accessory::SetDuration</a></div><div class="ttdeci">void SetDuration(unsigned long inDuration)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00344">Accessory.hpp:344</a></div></div>
<div class="ttc" id="classPort_html"><div class="ttname"><a href="classPort.html">Port</a></div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00061">Port.hpp:61</a></div></div>
<div class="ttc" id="classAccessoryServo_html_a34b0fe645b1cadd12aae4c09574c8bc5"><div class="ttname"><a href="classAccessoryServo.html#a34b0fe645b1cadd12aae4c09574c8bc5">AccessoryServo::begin</a></div><div class="ttdeci">void begin(Port *inpPort, unsigned long inDurationMilli = 0, int inMinimumPosition = 0, int inMaximumPosition = 180, int inMovingPositionsNumber = 1)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00020">AccessoryServo.cpp:20</a></div></div>
<div class="ttc" id="classAccessory_html_a7079494cf9cb5130e5b3a5762e04e947"><div class="ttname"><a href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">Accessory::prevState</a></div><div class="ttdeci">ACC_STATE prevState</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00170">Accessory.hpp:170</a></div></div>
<div class="ttc" id="classAccessory_html_ae1ebffdf3fe753e3c5e7d05c2a61fd18"><div class="ttname"><a href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">Accessory::pPort</a></div><div class="ttdeci">Port * pPort</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00167">Accessory.hpp:167</a></div></div>
<div class="ttc" id="classAccessoryServo_html_aff937dbf8b0adc731c408bafeae3ea35"><div class="ttname"><a href="classAccessoryServo.html#aff937dbf8b0adc731c408bafeae3ea35">AccessoryServo::AccessoryServo</a></div><div class="ttdeci">AccessoryServo()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryServo_8cpp_source.html#l00012">AccessoryServo.cpp:12</a></div></div>
<div class="ttc" id="Accessories_8h_html"><div class="ttname"><a href="Accessories_8h.html">Accessories.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>AccessoryServo.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
